package com.fairphone.fplauncher3;

import android.content.ComponentName;
import android.content.Intent;
import android.content.SharedPreferences;
import android.content.SharedPreferences.OnSharedPreferenceChangeListener;
import android.content.pm.LauncherActivityInfo;
import android.graphics.Rect;
import android.os.Bundle;
import android.view.Menu;
import android.view.View;

import com.android.launcher3.AppInfo;
import com.android.launcher3.InsettableFrameLayout;
import com.android.launcher3.Launcher;
import com.android.launcher3.LauncherCallbacks;
import com.android.launcher3.Utilities;
import com.android.launcher3.allapps.AllAppsSearchBarController;
import com.android.launcher3.compat.UserHandleCompat;
import com.android.launcher3.util.ComponentKey;

import java.io.FileDescriptor;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.List;

import com.fairphone.fplauncher3.edgeswipe.FavoritesToHotseatConverter;
import com.fairphone.fplauncher3.helper.UsageStatsHelper;

public class FairphoneLauncherCallbacks implements LauncherCallbacks, OnSharedPreferenceChangeListener {

    private final Launcher mLauncher;
    private List<ComponentKey> mPredictedApps;

    public FairphoneLauncherCallbacks(Launcher launcher) {
        mLauncher = launcher;
    }

    @Override
    public void preOnCreate() {

    }

    @Override
    public void onCreate(Bundle savedInstanceState) {

    }

    @Override
    public void preOnResume() {

    }

    @Override
    public void onResume() {
        updatePredictedApps();
    }

    @Override
    public void onStart() {

    }

    @Override
    public void onStop() {

    }

    @Override
    public void onPause() {

    }

    @Override
    public void onDestroy() {

    }

    @Override
    public void onSaveInstanceState(Bundle outState) {

    }

    @Override
    public void onPostCreate(Bundle savedInstanceState) {

    }

    @Override
    public void onNewIntent(Intent intent) {

    }

    @Override
    public void onActivityResult(int requestCode, int resultCode, Intent data) {

    }

    @Override
    public void onRequestPermissionsResult(int requestCode, String[] permissions, int[] grantResults) {

    }

    @Override
    public void onWindowFocusChanged(boolean hasFocus) {

    }

    @Override
    public boolean onPrepareOptionsMenu(Menu menu) {
        return false;
    }

    @Override
    public void dump(String prefix, FileDescriptor fd, PrintWriter w, String[] args) {

    }

    @Override
    public void onHomeIntent() {

    }

    @Override
    public boolean handleBackPressed() {
        return false;
    }

    @Override
    public void onTrimMemory(int level) {

    }

    @Override
    public void onLauncherProviderChange() {

    }

    @Override
    public void finishBindingItems(boolean upgradePath) {
        if (!FavoritesToHotseatConverter.hasMigrationRunAlready(mLauncher)) {
            FavoritesToHotseatConverter.migrateFavoritesToHotseat(mLauncher);
        }
    }

    @Override
    public void onClickAllAppsButton(View v) {

    }

    @Override
    public void bindAllApplications(ArrayList<AppInfo> apps) {

    }

    @Override
    public void onClickFolderIcon(View v) {

    }

    @Override
    public void onClickAppShortcut(View v) {

    }

    @Override
    public void onClickPagedViewIcon(View v) {

    }

    @Override
    public void onClickWallpaperPicker(View v) {

    }

    @Override
    public void onClickSettingsButton(View v) {

    }

    @Override
    public void onClickAddWidgetButton(View v) {

    }

    @Override
    public void onPageSwitch(View newPage, int newPageIndex) {

    }

    @Override
    public void onWorkspaceLockedChanged() {

    }

    @Override
    public void onDragStarted(View view) {

    }

    @Override
    public void onInteractionBegin() {

    }

    @Override
    public void onInteractionEnd() {

    }

    @Override
    public boolean forceDisableVoiceButtonProxy() {
        return false;
    }

    @Override
    public boolean providesSearch() {
        // In combination with null value of getQsbBar(): Removes search bar
        return true;
    }

    @Override
    public boolean startSearch(String initialQuery, boolean selectInitialQuery, Bundle appSearchData, Rect sourceBounds) {
        return false;
    }

    @Override
    public boolean startSearchFromAllApps(String query) {
        return false;
    }

    @Override
    public void startVoice() {

    }

    @Override
    public boolean hasCustomContentToLeft() {
        return false;
    }

    @Override
    public void populateCustomContentContainer() {

    }

    @Override
    public View getQsbBar() {
        return null;
    }

    @Override
    public Intent getFirstRunActivity() {
        return null;
    }

    @Override
    public boolean hasFirstRunActivity() {
        return false;
    }

    @Override
    public boolean hasDismissableIntroScreen() {
        return false;
    }

    @Override
    public View getIntroScreen() {
        return null;
    }

    @Override
    public boolean shouldMoveToDefaultScreenOnHomeIntent() {
        return true;
    }

    @Override
    public boolean hasSettings() {
        return false;
    }

    @Override
    public ComponentName getWallpaperPickerComponent() {
        return null;
    }

    @Override
    public boolean overrideWallpaperDimensions() {
        return false;
    }

    @Override
    public boolean isLauncherPreinstalled() {
        return false;
    }

    @Override
    public AllAppsSearchBarController getAllAppsSearchBarController() {
        return null;
    }

    @Override
    public List<ComponentKey> getPredictedApps() {
        return mPredictedApps;
    }

    /**
     * Returning true will immediately result in a call to {@link #setLauncherOverlayView(ViewGroup,
     * Launcher.LauncherOverlayCallbacks)}.
     *
     * @return true if this launcher extension will provide an overlay
     */
    @Override
    public boolean hasLauncherOverlay() {
        return false;
    }

    /**
     * Handshake to establish an overlay relationship
     *
     * @param container Full screen overlay ViewGroup into which custom views can be placed.
     * @param callbacks A set of callbacks provided by Launcher in relation to the overlay
     * @return an interface used to make requests and notify the Launcher in relation to the overlay
     */
    @Override
    public Launcher.LauncherOverlay setLauncherOverlayView(InsettableFrameLayout container, Launcher.LauncherOverlayCallbacks callbacks) {
        return null;
    }

    /**
     * Sets the callbacks to allow reacting the actions of search overlays of the launcher.
     *
     * @param callbacks A set of callbacks to the Launcher, is actually a LauncherSearchCallback,
     *                  but for implementation purposes is passed around as an object.
     */
    @Override
    public void setLauncherSearchCallback(Object callbacks) {

    }

    /**
     * Called when a shared preference is changed, added, or removed. This
     * may be called even if a preference is set to its existing value.
     * <p>
     * <p>This callback will be run on your main thread.
     *
     * @param sharedPreferences The {@link SharedPreferences} that received
     *                          the change.
     * @param key               The key of the preference that was changed, added, or
     */
    @Override
    public void onSharedPreferenceChanged(SharedPreferences sharedPreferences, String key) {

    }

    private void updatePredictedApps() {
        if (UsageStatsHelper.isUsageDataAvailable()) {
            new Runnable() {
                public void run() {
                    mPredictedApps = UsageStatsHelper.getMostUsedApps(mLauncher);
                }
            }.run();
        }
    }
}
